## rustc 1.58.1+dfsg1~ubuntu1

=== src/test/run-make-fulldeps/alloc-no-oom-handling/Makefile ===
-include ../tools.mk

all:
	$(RUSTC) --edition=2018 --crate-type=rlib ../../../../library/alloc/src/lib.rs --cfg feature=\"external_crate\" --cfg no_global_oom_handling

=== src/test/run-make-fulldeps/allow-warnings-cmdline-stability/Makefile ===
-include ../tools.mk

# Test that -A warnings makes the 'empty trait list for derive' warning go away
DEP=$(shell $(RUSTC) bar.rs)
OUT=$(shell $(RUSTC) foo.rs -A warnings 2>&1 | grep "warning" )

all: foo bar
	test -z '$(OUT)'

# These are just to ensure that the above commands actually work
bar:
	$(RUSTC) bar.rs

foo: bar
	$(RUSTC) foo.rs -A warnings

=== src/test/run-make-fulldeps/compiler-rt-works-on-mingw/Makefile ===
-include ../tools.mk

# only-windows-gnu

all:
	$(CXX) foo.cpp -c -o $(TMPDIR)/foo.o
	$(AR) crus $(TMPDIR)/libfoo.a $(TMPDIR)/foo.o
	$(RUSTC) foo.rs -lfoo -lstdc++
	$(call RUN,foo)

=== src/test/run-make-fulldeps/coverage-llvmir/Makefile ===
# needs-profiler-support

-include ../coverage/coverage_tools.mk

BASEDIR=../coverage-llvmir

ifeq ($(UNAME),Darwin)
	INSTR_PROF_DATA_SUFFIX=,regular,live_support
	DATA_SECTION_PREFIX=__DATA,
	LLVM_COV_SECTION_PREFIX=__LLVM_COV,
	COMDAT_IF_SUPPORTED=
else
	INSTR_PROF_DATA_SUFFIX=
	DATA_SECTION_PREFIX=
	LLVM_COV_SECTION_PREFIX=
	COMDAT_IF_SUPPORTED=, comdat
endif

DEFINE_INTERNAL=define internal

ifdef IS_WINDOWS
	LLVM_FILECHECK_OPTIONS=\
		-check-prefixes=CHECK,WINDOWS \
		-DDEFINE_INTERNAL='$(DEFINE_INTERNAL)' \
		-DCOMDAT_IF_SUPPORTED='$(COMDAT_IF_SUPPORTED)' \
		-DINSTR_PROF_DATA='.lprfd$$M' \
		-DINSTR_PROF_NAME='.lprfn$$M' \
		-DINSTR_PROF_CNTS='.lprfc$$M' \
		-DINSTR_PROF_VALS='.lprfv$$M' \
		-DINSTR_PROF_VNODES='.lprfnd$$M' \
		-DINSTR_PROF_COVMAP='.lcovmap$$M' \
		-DINSTR_PROF_COVFUN='.lcovfun$$M' \
		-DINSTR_PROF_ORDERFILE='.lorderfile$$M'
else
	LLVM_FILECHECK_OPTIONS=\
		-check-prefixes=CHECK \
		-DDEFINE_INTERNAL='$(DEFINE_INTERNAL)' \
		-DCOMDAT_IF_SUPPORTED='$(COMDAT_IF_SUPPORTED)' \
		-DINSTR_PROF_DATA='$(DATA_SECTION_PREFIX)__llvm_prf_data$(INSTR_PROF_DATA_SUFFIX)' \
		-DINSTR_PROF_NAME='$(DATA_SECTION_PREFIX)__llvm_prf_names' \
		-DINSTR_PROF_CNTS='$(DATA_SECTION_PREFIX)__llvm_prf_cnts' \
		-DINSTR_PROF_VALS='$(DATA_SECTION_PREFIX)__llvm_prf_vals' \
		-DINSTR_PROF_VNODES='$(DATA_SECTION_PREFIX)__llvm_prf_vnds' \
		-DINSTR_PROF_COVMAP='$(LLVM_COV_SECTION_PREFIX)__llvm_covmap' \
		-DINSTR_PROF_COVFUN='$(LLVM_COV_SECTION_PREFIX)__llvm_covfun' \
		-DINSTR_PROF_ORDERFILE='$(DATA_SECTION_PREFIX)__llvm_orderfile'
endif

all: test_llvm_ir

test_llvm_ir:
	# Compile the test program with non-experimental coverage instrumentation, and generate LLVM IR
	$(RUSTC) $(BASEDIR)/testprog.rs \
			-Zinstrument-coverage \
			--emit=llvm-ir

	cat "$(TMPDIR)"/testprog.ll | \
			"$(LLVM_FILECHECK)" $(BASEDIR)/filecheck.testprog.txt $(LLVM_FILECHECK_OPTIONS)

=== src/test/run-make-fulldeps/dep-info-spaces/Makefile ===
-include ../tools.mk

# ignore-windows
# ignore-freebsd
# FIXME: (windows: see `../dep-info/Makefile`)

all:
	cp lib.rs $(TMPDIR)/
	cp 'foo foo.rs' $(TMPDIR)/
	cp bar.rs $(TMPDIR)/
	$(RUSTC) --emit link,dep-info --crate-type=lib $(TMPDIR)/lib.rs
	sleep 1
	touch $(TMPDIR)/'foo foo.rs'
	-rm -f $(TMPDIR)/done
	$(MAKE) -drf Makefile.foo
	rm $(TMPDIR)/done
	pwd
	$(MAKE) -drf Makefile.foo
	rm $(TMPDIR)/done && exit 1 || exit 0

=== src/test/run-make-fulldeps/error-found-staticlib-instead-crate/Makefile ===
-include ../tools.mk

all:
	$(RUSTC) foo.rs --crate-type staticlib
	$(RUSTC) bar.rs 2>&1 | $(CGREP) "found staticlib"

=== src/test/run-make-fulldeps/extern-flag-rename-transitive/Makefile ===
-include ../tools.mk

all:
	$(RUSTC) foo.rs
	$(RUSTC) bar.rs
	$(RUSTC) baz.rs --extern a=$(TMPDIR)/libfoo.rlib

=== src/test/run-make-fulldeps/include_bytes_deps/Makefile ===
-include ../tools.mk

# ignore-freebsd

all:
	$(RUSTC) --emit dep-info main.rs
	$(CGREP) "input.txt" "input.bin" "input.md" < $(TMPDIR)/main.d

=== src/test/run-make-fulldeps/intrinsic-unreachable/Makefile ===
-include ../tools.mk

# ignore-windows-msvc
#
# Because of Windows exception handling, the code is not necessarily any shorter.
# https://github.com/llvm-mirror/llvm/commit/64b2297786f7fd6f5fa24cdd4db0298fbf211466

all:
	$(RUSTC) -O --emit asm exit-ret.rs
	$(RUSTC) -O --emit asm exit-unreachable.rs
	test `wc -l < $(TMPDIR)/exit-unreachable.s` -lt `wc -l < $(TMPDIR)/exit-ret.s`

=== src/test/run-make-fulldeps/issue-11908/Makefile ===
# This test ensures that if you have the same rlib or dylib at two locations
# in the same path that you don't hit an assertion in the compiler.
#
# Note that this relies on `liburl` to be in the path somewhere else,
# and then our aux-built libraries will collide with liburl (they have
# the same version listed)

-include ../tools.mk

all:
	mkdir $(TMPDIR)/other
	$(RUSTC) foo.rs --crate-type=dylib -C prefer-dynamic
	mv $(call DYLIB,foo) $(TMPDIR)/other
	$(RUSTC) foo.rs --crate-type=dylib -C prefer-dynamic
	$(RUSTC) bar.rs -L $(TMPDIR)/other
	rm -rf $(TMPDIR)
	mkdir -p $(TMPDIR)/other
	$(RUSTC) foo.rs --crate-type=rlib
	mv $(TMPDIR)/libfoo.rlib $(TMPDIR)/other
	$(RUSTC) foo.rs --crate-type=rlib
	$(RUSTC) bar.rs -L $(TMPDIR)/other

=== src/test/run-make-fulldeps/many-crates-but-no-match/Makefile ===
-include ../tools.mk

# Modelled after ui/changing-crates.rs test, but this one puts
# more than one (mismatching) candidate crate into the search path,
# which did not appear directly expressible in UI testing infrastructure.
#
# Note that we move the built libraries into target direcrtories rather than
# use the `--out-dir` option because the `../tools.mk` file already bakes a
# use of `--out-dir` into the definition of $(RUSTC).

A1=$(TMPDIR)/a1
A2=$(TMPDIR)/a2
A3=$(TMPDIR)/a3

# A hack to match distinct lines of output from a single run.
LOG=$(TMPDIR)/log.txt

all:
	mkdir -p $(A1) $(A2) $(A3)
	$(RUSTC) --crate-type=rlib crateA1.rs
	mv $(TMPDIR)/$(call RLIB_GLOB,crateA) $(A1)
	$(RUSTC) --crate-type=rlib -L $(A1) crateB.rs
	$(RUSTC) --crate-type=rlib crateA2.rs
	mv $(TMPDIR)/$(call RLIB_GLOB,crateA) $(A2)
	$(RUSTC) --crate-type=rlib crateA3.rs
	mv $(TMPDIR)/$(call RLIB_GLOB,crateA) $(A3)
	# Ensure crateC fails to compile since A1 is "missing" and A2/A3 hashes do not match
	$(RUSTC) -L $(A2) -L $(A3) crateC.rs >$(LOG) 2>&1 || true
	$(CGREP) \
		'found possibly newer version of crate `crateA` which `crateB` depends on' \
		'note: perhaps that crate needs to be recompiled?' \
		'crate `crateA`:' \
		'crate `crateB`:' \
		< $(LOG)
	# the 'crate `crateA`' will match two entries.

=== src/test/run-make-fulldeps/mixing-deps/Makefile ===
-include ../tools.mk

all:
	$(RUSTC) both.rs -C prefer-dynamic
	$(RUSTC) dylib.rs -C prefer-dynamic
	$(RUSTC) prog.rs
	$(call RUN,prog)

=== debian/changelog ===
rustc (1.58.1+dfsg1~ubuntu1-0ubuntu2) jammy; urgency=medium

  * d/p/ubuntu-fix-crossbeam-CVE-2022-23639.patch: amended to also patch the
    0.7.2 version of the crate
  * Downgrade cargo from rustc Recommends to Suggests to make rustc promotable to
    main. (LP: #1966200)

 -- Simon Chopin <simon.chopin@canonical.com>  Fri, 01 Apr 2022 11:54:57 +0200

rustc (1.58.1+dfsg1~ubuntu1-0ubuntu1) jammy; urgency=medium

  * New upstream version.
    - d/copyright: exclude the new NanumBarunGothic fonts
    - d/copyright: refresh the unused deps section
    - revert the LLVM vendoring
    - revert the CFLAGS scrubing
    - d/p/{u-89950.patch}: Removed, merged upstream
    - Refreshed patches:
      - d/p/d-0000-ignore-removed-submodules.patch
      - d/p/d-rustc-fix-mips64el-bootstrap.patch
      - d/p/d-rustdoc-disable-embedded-fonts.patch
      - d/p/d-bootstrap-cargo-doc-paths.patch
    - Unfuzzed patches: 
      - d-0005-clippy-feature-sync.patch
      - d-bootstrap-rustflags.patch
      - d-bootstrap-cargo-doc-paths.patch
      - u-cc-627.patch
    - New patch u-linkchecker-symlinks.patch to fix an issue in
      the linkchecker triggered by our symlink to the system fonts dir
    - d/control: Add fonts-nanum to the rust-doc deps
    - d/control: Add the rust-doc deps as build-deps for the linkchecker tests
  * d/rules: bump the parallelism level to 4
  * Re-enable the tests within the Debian-specified limits
  * Explicitly disable LTO
  * Add a self-build autopkgtest
  * Ship the Cargo.lock file along with the compiler to identify which crates
    were bundled in.
  * d/p/ubuntu-disable-armhf-debuginfo-failures.patch: temporary to work
    around the armhf debuginfo test failures
  * d/p/ubuntu-ignore-arm-doctest.patch: Patch out the bad doctests for the
    instruction_set errors
  * d/p/ubuntu-fix-crossbeam-CVE-2022-23639.patch: cherry-pick to fix CVE-2022-23639

 -- Simon Chopin <simon.chopin@canonical.com>  Thu, 24 Feb 2022 13:41:38 +0100

rustc (1.57.0+dfsg1+llvm-0ubuntu2) jammy; urgency=medium

  * d/p/d-bootstrap-rustflags.patch: remove the warnings bit, use the option
    "deny-warnings = false" in d/config.toml.in instead

 -- Simon Chopin <simon.chopin@canonical.com>  Thu, 27 Jan 2022 11:21:03 +0100

rustc (1.57.0+dfsg1+llvm-0ubuntu1) jammy; urgency=medium

  * New upstream version.
  * Refresh patches.
  * d/patches/{u-89591.patch,u-88668.patch,u-89772.patch}: Remove as upstream
    now includes these patches.
  * d/patches/d-bootstrap-dont-download-stage0.patch: Remove, no longer
    needed.
  * d/patches/ubuntu-memchr-features.patch: Fix obscure ftbfs from mismatched
    features.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Fri, 21 Jan 2022 08:42:03 +1300

rustc (1.56.0+dfsg1+llvm-2ubuntu2) jammy; urgency=medium

  * debian/patches/u-ensure-aarch64-lse-object-files-have-distinct-names-in-an-archive.patch:
    Backport patch from upstream, to fix "error: object name conflicts in
    archive" when building rust programs on arm64 (librsvg is currently
    affected).

 -- Iain Lane <iain@orangesquash.org.uk>  Tue, 18 Jan 2022 10:25:30 +0000

rustc (1.56.0+dfsg1+llvm-2ubuntu1) jammy; urgency=medium

  * Merge 1.56.0+dfsg1-2 from Debian unstable. (LP: #1952104)
    Remaining changes:
    - Use the bundled llvm to avoid having to do llvm updates in order to
      deliver rust updates
      - update debian/config.toml.in
      - update debian/control
      - update debian/copyright
      - update debian/rules
    - Build-Depend on libc6-dbg on armhf, to workaround a crash in ld.so
      during some debuginfo tests
      - update debian/control
    - Add a hack to ensure the stage0 compiler is extracted to the correct
      location
      - update debian/make_orig-stage0_tarball.sh
    - Scrub -g from CFLAGS and CXXFLAGS in order to let rustbuild control
      whether LLVM is compiled with debug symbols
      - update debian/rules
    - On i386, only build debuginfo for libstd
      - update debian/rules
    - Ignore all test failures on every architecture
      - update debian/rules
    - Version the Build-Conflict on gdb-minimal as gdb now Provides it
      - update debian/control
    - Adjust the rustc Breaks/Replaces libstd-rust-dev version to fix an
      upgrade issue
      - update debian/control
    - Adjust debian/watch to include +llvm in upstream version.
      - update debian/watch
    - Add Build-Depends-Indep: libssl-dev
    - Revert workaround for upstream bug #74786
    - Disable wasm build as build dependencies not currently available in
      Ubuntu.
    - Do not build windows cross compiler.
    - Reduce parallelism on all arches other than riscv64 to avoid OOMs
      during build.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Tue, 14 Dec 2021 10:24:02 +1300

rustc (1.55.0+dfsg1+llvm-2ubuntu1) jammy; urgency=medium

  * Merge 1.55.0+dfsg1-2 from Debian unstable. (LP: #1952104)
    Remaining changes:
    - Use the bundled llvm to avoid having to do llvm updates in order to
      deliver rust updates
      - update debian/config.toml.in
      - update debian/control
      - update debian/copyright
      - update debian/rules
    - Build-Depend on libc6-dbg on armhf, to workaround a crash in ld.so
      during some debuginfo tests
      - update debian/control
    - Add a hack to ensure the stage0 compiler is extracted to the correct
      location
      - update debian/make_orig-stage0_tarball.sh
    - Scrub -g from CFLAGS and CXXFLAGS in order to let rustbuild control
      whether LLVM is compiled with debug symbols
      - update debian/rules
    - On i386, only build debuginfo for libstd
      - update debian/rules
    - Ignore all test failures on every architecture
      - update debian/rules
    - Version the Build-Conflict on gdb-minimal as gdb now Provides it
      - update debian/control
    - Adjust the rustc Breaks/Replaces libstd-rust-dev version to fix an
      upgrade issue
      - update debian/control


=== debian/control ===
Source: rustc
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
Uploaders:
 Ximin Luo <infinity0@debian.org>,
 Sylvestre Ledru <sylvestre@debian.org>
Rules-Requires-Root: no
# :native annotations are to support cross-compiling, see README.Debian
Build-Depends:
 debhelper (>= 9),
 debhelper-compat (= 13),
 dpkg-dev (>= 1.17.14),
 python3:native,
 cargo:native (>= 0.40.0)      <!pkg.rustc.dlstage0>,
 rustc:native (>= 1.57.0+dfsg) <!pkg.rustc.dlstage0>,
 rustc:native (<= 1.58.1++)    <!pkg.rustc.dlstage0>,
 llvm-13-dev:native,
 llvm-13-tools:native,
 libllvm13 (>= 1:13.0.0),
 cmake (>= 3.0) | cmake3,
# needed by some vendor crates
 pkg-config,
# this is sometimes needed by rustc_llvm
 zlib1g-dev:native,
 zlib1g-dev,
# used by rust-installer
 liblzma-dev:native,
# test dependencies:
 binutils (>= 2.26) <!nocheck> | binutils-2.26 <!nocheck>,
 git <!nocheck>,
 procps <!nocheck>,
# Resources loaded from the docs, checked by linkchecker
 libjs-jquery <!nocheck>,
 libjs-highlight.js <!nocheck>,
 libjs-mathjax <!nocheck>,
 fonts-open-sans <!nocheck>,
 fonts-font-awesome <!nocheck>,
 fonts-nanum <!nocheck>,
# below are optional tools even for 'make check'
 gdb (>= 7.12) <!nocheck>,
 libc6-dbg [armhf],
# Extra build-deps needed for x.py to download stuff in pkg.rustc.dlstage0.
 curl <pkg.rustc.dlstage0>,
 ca-certificates <pkg.rustc.dlstage0>,
Build-Depends-Indep:
 clang-13:native,
 libssl-dev,
Build-Conflicts: gdb-minimal (<< 8.1-0ubuntu6) <!nocheck>
Standards-Version: 4.2.1
Homepage: http://www.rust-lang.org/
Vcs-Git: https://salsa.debian.org/rust-team/rust.git
Vcs-Browser: https://salsa.debian.org/rust-team/rust

Package: rustc
Architecture: any
Multi-Arch: allowed
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends},
 libstd-rust-dev (= ${binary:Version}),
 gcc, libc-dev, binutils (>= 2.26)
Recommends:
# llvm is needed for llvm-dwp for -C split-debuginfo=packed
 llvm-13,
Suggests:
# lld and clang are needed for wasm compilation
 cargo (>= 0.58.0~~), cargo (<< 0.59.0~~),
 lld-13, clang-13,
Replaces: libstd-rust-dev (<< 1.26.2+dfsg1+llvm-0ubuntu1~~)
Breaks: libstd-rust-dev (<< 1.26.2+dfsg1+llvm-0ubuntu1~~)
Description: Rust systems programming language
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.

Package: libstd-rust-1.58
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Rust standard libraries
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains the standard Rust libraries, built as dylibs,
 needed to run dynamically-linked Rust programs (-C prefer-dynamic).

Package: libstd-rust-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends},
 libstd-rust-1.58 (= ${binary:Version}),
Description: Rust standard libraries - development files
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains development files for the standard Rust libraries,
 needed to compile Rust programs. It may also be installed on a system
 of another host architecture, for cross-compiling to this architecture.

Package: rust-gdb
Architecture: all
Depends: gdb, ${misc:Depends}
Suggests: gdb-doc
Replaces: rustc (<< 1.1.0+dfsg1-1)
Description: Rust debugger (gdb)
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains pretty printers and a wrapper script for
 invoking gdb on rust binaries.

Package: rust-lldb
Architecture: all
# When updating, also update rust-lldb.links
Depends: lldb-13, ${misc:Depends}, python3-lldb-13
Replaces: rustc (<< 1.1.0+dfsg1-1)
Description: Rust debugger (lldb)
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains pretty printers and a wrapper script for
 invoking lldb on rust binaries.

Package: rust-doc
Section: doc
Architecture: all
Build-Profiles: <!nodoc>
Depends: ${misc:Depends},
 libjs-jquery, libjs-highlight.js, libjs-mathjax,
 fonts-open-sans, fonts-font-awesome, fonts-nanum
Recommends: cargo-doc
Description: Rust systems programming language - Documentation
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains the Rust tutorial, language reference and
 standard library documentation.

Package: rust-src
Architecture: all
Depends: ${misc:Depends}
Description: Rust systems programming language - source code
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains sources of the Rust compiler and standard
 libraries, useful for IDEs and code analysis tools such as Racer.

Package: rust-clippy
Architecture: any
Multi-Arch: allowed
Depends: ${misc:Depends}, ${shlibs:Depends},
 libstd-rust-1.58 (= ${binary:Version})
Recommends: cargo
Description: Rust linter
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains 'clippy', a linter to catch common mistakes and improve
 your Rust code as well a collection of over 400 compatible lints.
 .
 Lints are divided into categories, each with a default lint level. You can
 choose how much Clippy is supposed to annoy help you by changing the lint
 level by category.
 .
 Clippy is integrated into the 'cargo' build tool, available via 'cargo clippy'.

Package: rustfmt
Architecture: any
Multi-Arch: allowed
Depends: ${misc:Depends}, ${shlibs:Depends},
Recommends: cargo
Description: Rust formatting helper
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains 'rustfmt', a tool for formatting Rust code according to
 style guidelines, as well as 'cargo-fmt', a helper enabling running rustfmt
 directly with 'cargo fmt'.

Package: rust-all
Architecture: all
Depends: ${misc:Depends}, ${shlibs:Depends},
 rustc (>= ${binary:Version}),
 rustfmt (>= ${binary:Version}),
 rust-clippy (>= ${binary:Version}),
 rust-gdb (>= ${binary:Version}) | rust-lldb (>= ${binary:Version}),
 cargo,
Recommends:
 cargo (>= 0.57.0~~), cargo (<< 0.58.0~~)
Suggests:
 rust-doc (>= ${binary:Version}),
 rust-src (>= ${binary:Version}),
 libstd-rust-dev-wasm32 (>= ${binary:Version}),
 libstd-rust-dev-windows (>= ${binary:Version}),
Description: Rust systems programming language - all developer tools
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package is an empty metapackage that depends on all developer tools

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# The build regressed back when LTO was systematized in Ubuntu.
# This should be periodically revisited.
export DEB_BUILD_MAINT_OPTIONS=optimize=-lto

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/vendor.mk
include /usr/share/dpkg/architecture.mk
SED_VERSION_SHORT := sed -re 's/([^.]+)\.([^.]+)\..*/\1.\2/'
RUST_VERSION := $(shell echo '$(DEB_VERSION_UPSTREAM)' | $(SED_VERSION_SHORT))
RUST_LONG_VERSION := $(shell echo '$(DEB_VERSION_UPSTREAM)' | sed -re 's/([^+]+).*/\1/')
LIBSTD_PKG := libstd-rust-$(RUST_VERSION)
# Sed expression that matches the "rustc" we have in our Build-Depends field
SED_RUSTC_BUILDDEP := sed -ne "/^Build-Depends:/,/^[^[:space:]\#]/{/^ *rustc:native .*,/p}" debian/control
# Version of /usr/bin/rustc
LOCAL_RUST_VERSION := $(shell rustc --version --verbose | sed -ne 's/^release: //p')

include /usr/share/dpkg/buildflags.mk
export CFLAGS CXXFLAGS CPPFLAGS LDFLAGS
export CARGO_HOME = $(CURDIR)/debian/cargo

# Defines DEB_*_RUST_TYPE triples
include debian/architecture.mk
# for dh_install substitution variable
export DEB_HOST_RUST_TYPE

# for dh_install substitution variable
export RUST_LONG_VERSION

DEB_DESTDIR := $(CURDIR)/debian/tmp

# Use system LLVM (comment out to use vendored LLVM)
LLVM_VERSION = 13
OLD_LLVM_VERSION = 12
# Make it easier to test against a custom LLVM
ifneq (,$(LLVM_DESTDIR))
LLVM_LIBRARY_PATH := $(LLVM_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH):$(LLVM_DESTDIR)/usr/lib
LD_LIBRARY_PATH := $(if $(LD_LIBRARY_PATH),$(LD_LIBRARY_PATH):$(LLVM_LIBRARY_PATH),$(LLVM_LIBRARY_PATH))
export LD_LIBRARY_PATH
endif

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
ifeq ($(DEB_HOST_ARCH),riscv64)
NJOBS := -j $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
NJOBS := -j 4
endif
endif
RUSTBUILD = RUST_BACKTRACE=1 python3 src/bootstrap/bootstrap.py $(NJOBS)
RUSTBUILD_FLAGS = --stage 2 --config debian/config.toml --on-fail env
# rust-tidy depends on lots of modules that we strip out of the build.
# it also tries to access the network for some reason. so just disable it.
RUSTBUILD_TEST = $(RUSTBUILD) test --no-fail-fast --exclude src/tools/tidy
# To run a specific test, run something like:
#   $ debian/rules override_dh_auto_test-arch \
#     RUSTBUILD_TEST_FLAGS="src/test/run-make --test-args extern-fn-struct"
# See src/bootstrap/README.md for more options.
RUSTBUILD_TEST_FLAGS =

# https://github.com/rust-lang/rust/issues/89744
# TODO: remove when we update cargo to 1.55 / 0.56
# upstream bug still exists and is under investigation, but is hidden by newer cargo
export CARGO_PROFILE_RELEASE_BUILD_OVERRIDE_OPT_LEVEL=0

update-version:
	oldver=$(shell $(SED_RUSTC_BUILDDEP) | sed -ne 's/.*(<= \(.*\)).*/\1/gp' | $(SED_VERSION_SHORT)); \
	newver=$(RUST_VERSION); \
	debian/update-version.sh $$oldver $$newver $(RUST_LONG_VERSION) $(CARGO_NEW)

# Below we detect how we're supposed to bootstrap the stage0 compiler. See
# README.Debian for more details of the cases described below.
#
PRECONFIGURE_CHECK = :
HAVE_BINARY_TARBALL := $(shell ls -1 stage0/*/*$(DEB_HOST_RUST_TYPE)* 2>/dev/null | wc -l)
DOWNLOAD_BOOTSTRAP := false
# allow not using the binary tarball although it exists
#ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 armhf i386 powerpc ppc64el s390x))
#  HAVE_BINARY_TARBALL := 0
#endif
ifeq (0,$(HAVE_BINARY_TARBALL))
    # Case A (Building from source): the extracted source tree does not include
    # a bootstrapping tarball for the current architecture e.g. because the
    # distro already has a rustc for this arch, or the uploader expects that
    # this requirement be fulfilled in some other way.
    #
    # Case A-1: the builder did not select the "pkg.rustc.dlstage0" build profile.
    # In this case, we use the distro's rustc - either the previous or current version.
    ifeq (,$(findstring pkg.rustc.dlstage0,$(DEB_BUILD_PROFILES)))
        # Make it easier to test against a custom rustc
        ifneq (,$(RUST_DESTDIR))
        RUST_LIBRARY_PATH := $(RUST_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH):$(RUST_DESTDIR)/usr/lib
        LD_LIBRARY_PATH := $(if $(LD_LIBRARY_PATH),$(LD_LIBRARY_PATH):$(RUST_LIBRARY_PATH),$(RUST_LIBRARY_PATH))
        export LD_LIBRARY_PATH
        endif
    #
    # Case A-2: the builder selected the "dlstage0" build profile.
    # In this case, the rust build scripts will download a stage0 into stage0/ and use that.
    # We don't need to do anything specific in this build file, so this case is empty.
    else
        DOWNLOAD_BOOTSTRAP := true
    endif
else
    # Case B (Bootstrapping a new distro): the extracted source tree does
    # include a bootstrapping tarball for the current architecture; see the
    # `source_orig-stage0` target below on how to build this.
    #
    # In this case, we'll bootstrap from the stage0 given in that tarball.
    # To ensure the uploader of the .dsc didn't make a mistake, we first check
    # that rustc isn't a Build-Depends for the current architecture.
    ifneq (,$(shell $(SED_RUSTC_BUILDDEP)))
    ifeq (,$(shell $(SED_RUSTC_BUILDDEP) | grep '!$(DEB_HOST_ARCH)'))
        PRECONFIGURE_CHECK = $(error found matches for stage0/*/*$(DEB_HOST_RUST_TYPE)*, \
          but rustc might be a Build-Depends for $(DEB_HOST_ARCH))
    endif
    endif
endif

BUILD_DOCS := true
ifneq (,$(findstring nodoc,$(DEB_BUILD_PROFILES)))
  BUILD_DOCS := false
endif
ifneq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
  BUILD_DOCS := false
endif

BUILD_WASM := false

BUILD_WINDOWS := false

MAKE_OPTIMISATIONS := true
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
  MAKE_OPTIMISATIONS := false
endif

VERBOSITY_SUB := $(words $(filter terse,$(DEB_BUILD_OPTIONS)))
VERBOSITY_ADD := $(words $(filter verbose,$(DEB_BUILD_OPTIONS)))
VERBOSITY := $(shell expr 2 + $(VERBOSITY_ADD) - $(VERBOSITY_SUB))

ifeq ($(shell test $(VERBOSITY) -ge 3; echo $$?),0)
  export DH_VERBOSE=1
endif

ifeq ($(shell test $(VERBOSITY) -le 0; echo $$?),0)
  export DH_QUIET=1
.SILENT:
endif

# Build products or non-source files in src/, that shouldn't go in rust-src
SRC_CLEAN = src/bootstrap/bootstrap.pyc \
	src/etc/__pycache__/

# Try to work around #933045
ifneq (,$(filter $(DEB_BUILD_ARCH), mips mipsel))
  SYSTEM_WORKAROUNDS += export MALLOC_ARENA_MAX=1;
endif

%:
	$(SYSTEM_WORKAROUNDS) dh $@ --parallel

.PHONY: .dbg-windows
.dbg-windows:
	@echo host=$(DEB_BUILD_ARCH) target=$(DEB_HOST_ARCH) BUILD_WINDOWS=$(BUILD_WINDOWS) WINDOWS_ARCH=$(WINDOWS_ARCH)

.PHONY: build
build:
	$(SYSTEM_WORKAROUNDS) dh $@ --parallel

override_dh_clean:
	# Upstream contains a lot of these
	dh_clean -XCargo.toml.orig

debian/config.toml: debian/config.toml.in debian/rules
	u="$(DEB_VERSION_UPSTREAM)"; \
	if [ "$$u" != "$${u%~beta.*+dfsg*}" ]; then channel="beta"; \
	else channel="stable"; fi; \
	m4  -DRELEASE_CHANNEL="$$channel" \
		-DDEB_BUILD_RUST_TYPE="$(DEB_BUILD_RUST_TYPE)" \
		-DDEB_HOST_RUST_TYPE="$(DEB_HOST_RUST_TYPE)" \
		-DDEB_TARGET_RUST_TYPE="$(DEB_TARGET_RUST_TYPE)" \
		-DDEB_BUILD_GNU_TYPE="$(DEB_BUILD_GNU_TYPE)" \
		-DDEB_HOST_GNU_TYPE="$(DEB_HOST_GNU_TYPE)" \
		-DDEB_TARGET_GNU_TYPE="$(DEB_TARGET_GNU_TYPE)" \
		-DMAKE_OPTIMISATIONS="$(MAKE_OPTIMISATIONS)" \
		-DVERBOSITY="$(VERBOSITY)" \
		-DLLVM_DESTDIR="$(LLVM_DESTDIR)" \
		-DLLVM_VERSION="$(LLVM_VERSION)" \
		-DRUST_DESTDIR="$(RUST_DESTDIR)" \
		"$<" > "$@"
	if $(DOWNLOAD_BOOTSTRAP) || [ $(HAVE_BINARY_TARBALL) != 0 ]; \
	  then sed -i -e '/^rustc = /d' -e '/^cargo = /d' "$@"; fi
# Work around low-memory (32-bit) architectures: https://github.com/rust-lang/rust/issues/45854
ifneq (,$(filter $(DEB_BUILD_ARCH), armhf armel i386 mips mipsel powerpc powerpcspe))
	sed -i -e 's/^debuginfo-level = .*/debuginfo-level = 0/g' "$@"
endif

check-no-old-llvm:
	# fail the build if we have any instances of OLD_LLVM_VERSION in debian, except for debian/changelog

=== debian/tests/control ===
Test-Command: ./debian/rules build
Depends: @, @builddeps@
Restrictions: rw-build-tree, allow-stderr

=== debian/watch ===
version=4
# if you need to download other versions replace the URL below with this one:
# https://static.rust-lang.org/dist/channel-rust-$VERSION.toml
# and also add searchmode=plain,\
# it's a bit slower to download, that's why we use the other one normally

opts="\
pgpsigurlmangle=s/$/.asc/,\
uversionmangle=s/(\d)[_.+-]?((beta|alpha)\.?\d*)$/$1~$2/,\
dversionmangle=s/\+dfsg\d*$//,\
downloadurlmangle=s/\.[gx]z/.xz/,\
filenamemangle=s/.*\/(.*)\.[gx]z(\..*)?/$1.xz$2/,\
repack,\
repacksuffix=+dfsg1~ubuntu1,\
compression=xz,\
" \
 https://forge.rust-lang.org/infra/other-installation-methods.html \
 https://(?:.*/)rustc?-(\d[\d.]*(?:-[\w.]+)?)-src\.tar\.[gx]z

## rustc 1.58.1+dfsg1

=== debian/changelog ===
rustc (1.58.1+dfsg1-1+rpi1) bookworm-staging; urgency=medium

  [changes brought forward from 1.15.1+dfsg1-1~exp3+rpi1 by Peter Michael Green <plugwash@raspbian.org> at Wed, 15 Mar 2017 10:16:18 +0000]
  * Build for armv6.
  [changes introduced in 1.18.0+dfsg1-4+rpi1 by Peter Michael Green]
  * Disable testsuite.
  [changes introduced in 1.37.0+dfsg1-1+rpi1 by Peter Michael Green]
  * Set DEB_BUILD_RUST_TYPE based on the compiler that is actually installed.
  [changes introduced in 1.42.0+dfsg1-1+rpi1 by Peter Michael Green]
  * Use the compiler itself rather than dpkg to detect DEB_BUILD_RUST_TYPE
  [changes introduced in 1.57.0+dfsg1-1+rpi1 by Peter Michael Green]
  * Disable testsuite for arch all builds as well.

 -- Raspbian forward porter <root@raspbian.org>  Thu, 21 Apr 2022 08:12:14 +0000

rustc (1.58.1+dfsg1-1) unstable; urgency=medium

  * Upload to unstable.

 -- Ximin Luo <infinity0@debian.org>  Tue, 29 Mar 2022 12:23:46 +0100

rustc (1.58.1+dfsg1-1~exp1) experimental; urgency=medium

  [ Fabian Gruenbichler ]
  * New upstream release.

 -- Ximin Luo <infinity0@debian.org>  Tue, 08 Mar 2022 11:32:29 +0000

rustc (1.57.0+dfsg1-1) unstable; urgency=medium

  * Upload to unstable. (Closes: #1005203)

 -- Ximin Luo <infinity0@debian.org>  Tue, 08 Mar 2022 10:51:18 +0000

rustc (1.57.0+dfsg1-1~exp1) experimental; urgency=medium

  [ Simon Chopin ]
  * d/p/d-bootstrap-rustflags.patch: remove the warnings bit, use the option
    "deny-warnings = false" in d/config.toml.in instead

  [ Fabian Grünbichler ]
  * Fix CVE-2022-21658 - std::fs::remove_dir_all TOCTOU symlink issue
  * New upstream release. (Closes: #1005203)

 -- Fabian Grünbichler <f.gruenbichler@proxmox.com>  Thu, 03 Feb 2022 19:14:04 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: rustc
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
+Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
 Uploaders:
  Ximin Luo <infinity0@debian.org>,
  Sylvestre Ledru <sylvestre@debian.org>
@@ -18,6 +17,8 @@
  rustc:native (<= 1.58.1++)    <!pkg.rustc.dlstage0>,
  llvm-13-dev:native,
  llvm-13-tools:native,
+ gcc-mingw-w64-x86-64-posix:native [amd64] <!nowindows>,
+ gcc-mingw-w64-i686-posix:native [i386] <!nowindows>,
  libllvm13 (>= 1:13.0.0),
  cmake (>= 3.0) | cmake3,
 # needed by some vendor crates
@@ -31,23 +32,16 @@
  binutils (>= 2.26) <!nocheck> | binutils-2.26 <!nocheck>,
  git <!nocheck>,
  procps <!nocheck>,
-# Resources loaded from the docs, checked by linkchecker
- libjs-jquery <!nocheck>,
- libjs-highlight.js <!nocheck>,
- libjs-mathjax <!nocheck>,
- fonts-open-sans <!nocheck>,
- fonts-font-awesome <!nocheck>,
- fonts-nanum <!nocheck>,
 # below are optional tools even for 'make check'
  gdb (>= 7.12) <!nocheck>,
- libc6-dbg [armhf],
 # Extra build-deps needed for x.py to download stuff in pkg.rustc.dlstage0.
  curl <pkg.rustc.dlstage0>,
  ca-certificates <pkg.rustc.dlstage0>,
 Build-Depends-Indep:
+ wasi-libc (>= 0.0~git20210922.ad51334~~) <!nowasm>,
+ wasi-libc (<= 0.0~git20210922.ad51334++) <!nowasm>,
  clang-13:native,
- libssl-dev,
-Build-Conflicts: gdb-minimal (<< 8.1-0ubuntu6) <!nocheck>
+Build-Conflicts: gdb-minimal <!nocheck>
 Standards-Version: 4.2.1
 Homepage: http://www.rust-lang.org/
 Vcs-Git: https://salsa.debian.org/rust-team/rust.git
@@ -61,14 +55,14 @@
  libstd-rust-dev (= ${binary:Version}),
  gcc, libc-dev, binutils (>= 2.26)
 Recommends:
+ cargo (>= 0.59.0~~), cargo (<< 0.60.0~~),
 # llvm is needed for llvm-dwp for -C split-debuginfo=packed
  llvm-13,
 Suggests:
 # lld and clang are needed for wasm compilation
- cargo (>= 0.58.0~~), cargo (<< 0.59.0~~),
  lld-13, clang-13,
-Replaces: libstd-rust-dev (<< 1.26.2+dfsg1+llvm-0ubuntu1~~)
-Breaks: libstd-rust-dev (<< 1.26.2+dfsg1+llvm-0ubuntu1~~)
+Replaces: libstd-rust-dev (<< 1.25.0+dfsg1-2~~)
+Breaks: libstd-rust-dev (<< 1.25.0+dfsg1-2~~)
 Description: Rust systems programming language
  Rust is a curly-brace, block-structured expression language.  It
  visually resembles the C language family, but differs significantly
@@ -127,6 +121,62 @@
  needed to compile Rust programs. It may also be installed on a system
  of another host architecture, for cross-compiling to this architecture.
 
+Package: libstd-rust-dev-windows
+Section: libdevel
+Architecture: amd64 i386
+Multi-Arch: same
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Recommends:
+ gcc-mingw-w64-x86-64-posix [amd64],
+ gcc-mingw-w64-i686-posix [i386],
+Build-Profiles: <!nowindows>
+Description: Rust standard libraries - development files
+ Rust is a curly-brace, block-structured expression language.  It
+ visually resembles the C language family, but differs significantly
+ in syntactic and semantic details.  Its design is oriented toward
+ concerns of "programming in the large", that is, of creating and
+ maintaining boundaries - both abstract and operational - that
+ preserve large-system integrity, availability and concurrency.
+ .
+ It supports a mixture of imperative procedural, concurrent actor,
+ object-oriented and pure functional styles.  Rust also supports
+ generic programming and meta-programming, in both static and dynamic
+ styles.
+ .
+ This package contains the standard Rust libraries including development files,
+ needed to cross-compile Rust programs to the *-pc-windows-gnu target
+ corresponding to the architecture of this package.
+
+Package: libstd-rust-dev-wasm32
+Section: libdevel
+Architecture: all
+Multi-Arch: foreign
+Depends: ${shlibs:Depends}, ${misc:Depends}
+# Embeds wasi-libc so doesn't need to depend on it
+# None of its licenses require source redistrib, so no need for Built-Using
+Recommends:
+ lld-13, clang-13,
+Suggests:
+# nodejs contains wasi-node for running the program
+ nodejs (>= 12.16),
+Build-Profiles: <!nowasm>
+Description: Rust standard libraries - development files
+ Rust is a curly-brace, block-structured expression language.  It
+ visually resembles the C language family, but differs significantly
+ in syntactic and semantic details.  Its design is oriented toward
+ concerns of "programming in the large", that is, of creating and
+ maintaining boundaries - both abstract and operational - that
+ preserve large-system integrity, availability and concurrency.
+ .
+ It supports a mixture of imperative procedural, concurrent actor,
+ object-oriented and pure functional styles.  Rust also supports
+ generic programming and meta-programming, in both static and dynamic
+ styles.
+ .
+ This package contains the standard Rust libraries including development files,
+ needed to cross-compile Rust programs to the wasm32-unknown-unknown and
+ wasm32-wasi targets.
+
 Package: rust-gdb
 Architecture: all
 Depends: gdb, ${misc:Depends}
@@ -175,7 +225,7 @@
 Build-Profiles: <!nodoc>
 Depends: ${misc:Depends},
  libjs-jquery, libjs-highlight.js, libjs-mathjax,
- fonts-open-sans, fonts-font-awesome, fonts-nanum
+ fonts-open-sans, fonts-font-awesome
 Recommends: cargo-doc
 Description: Rust systems programming language - Documentation
  Rust is a curly-brace, block-structured expression language.  It
@@ -241,53 +291,3 @@
  Clippy is integrated into the 'cargo' build tool, available via 'cargo clippy'.
 
 Package: rustfmt
-Architecture: any
-Multi-Arch: allowed
-Depends: ${misc:Depends}, ${shlibs:Depends},
-Recommends: cargo
-Description: Rust formatting helper
- Rust is a curly-brace, block-structured expression language.  It
- visually resembles the C language family, but differs significantly
- in syntactic and semantic details.  Its design is oriented toward
- concerns of "programming in the large", that is, of creating and
- maintaining boundaries - both abstract and operational - that
- preserve large-system integrity, availability and concurrency.
- .
- It supports a mixture of imperative procedural, concurrent actor,
- object-oriented and pure functional styles.  Rust also supports
- generic programming and meta-programming, in both static and dynamic
- styles.
- .
- This package contains 'rustfmt', a tool for formatting Rust code according to
- style guidelines, as well as 'cargo-fmt', a helper enabling running rustfmt
- directly with 'cargo fmt'.
-
-Package: rust-all
-Architecture: all
-Depends: ${misc:Depends}, ${shlibs:Depends},
- rustc (>= ${binary:Version}),
- rustfmt (>= ${binary:Version}),
- rust-clippy (>= ${binary:Version}),
- rust-gdb (>= ${binary:Version}) | rust-lldb (>= ${binary:Version}),
- cargo,
-Recommends:
- cargo (>= 0.57.0~~), cargo (<< 0.58.0~~)
-Suggests:
- rust-doc (>= ${binary:Version}),
- rust-src (>= ${binary:Version}),
- libstd-rust-dev-wasm32 (>= ${binary:Version}),
- libstd-rust-dev-windows (>= ${binary:Version}),
-Description: Rust systems programming language - all developer tools
- Rust is a curly-brace, block-structured expression language.  It
- visually resembles the C language family, but differs significantly
- in syntactic and semantic details.  Its design is oriented toward
- concerns of "programming in the large", that is, of creating and
- maintaining boundaries - both abstract and operational - that
- preserve large-system integrity, availability and concurrency.
- .
- It supports a mixture of imperative procedural, concurrent actor,
- object-oriented and pure functional styles.  Rust also supports
- generic programming and meta-programming, in both static and dynamic
- styles.
- .
- This package is an empty metapackage that depends on all developer tools

=== debian/rules ===
--- 
+++ 
@@ -1,9 +1,5 @@
 #!/usr/bin/make -f
 # -*- makefile -*-
-
-# The build regressed back when LTO was systematized in Ubuntu.
-# This should be periodically revisited.
-export DEB_BUILD_MAINT_OPTIONS=optimize=-lto
 
 include /usr/share/dpkg/pkg-info.mk
 include /usr/share/dpkg/vendor.mk
@@ -42,11 +38,7 @@
 endif
 
 ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
-ifeq ($(DEB_HOST_ARCH),riscv64)
 NJOBS := -j $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
-else
-NJOBS := -j 4
-endif
 endif
 RUSTBUILD = RUST_BACKTRACE=1 python3 src/bootstrap/bootstrap.py $(NJOBS)
 RUSTBUILD_FLAGS = --stage 2 --config debian/config.toml --on-fail env
@@ -125,9 +117,32 @@
   BUILD_DOCS := false
 endif
 
-BUILD_WASM := false
-
-BUILD_WINDOWS := false
+BUILD_WASM := true
+ifneq (,$(findstring nowasm,$(DEB_BUILD_PROFILES)))
+  BUILD_WASM := false
+endif
+
+WINDOWS_SUPPORT := amd64 i386
+BUILD_WINDOWS := true
+ifneq (,$(findstring nowindows,$(DEB_BUILD_PROFILES)))
+  BUILD_WINDOWS := false
+endif
+ifeq (,$(filter $(DEB_HOST_ARCH), $(WINDOWS_SUPPORT)))
+  BUILD_WINDOWS := false
+else
+  ifeq (,$(filter $(DEB_BUILD_ARCH), $(WINDOWS_SUPPORT)))
+    ifeq (true,$(BUILD_WINDOWS))
+      $(error cannot cross-compile from $(DEB_BUILD_ARCH) to $(DEB_HOST_ARCH), unless "nowindows" is in DEB_BUILD_PROFILES)
+    endif
+  endif
+  ifeq (i386,$(DEB_HOST_ARCH))
+    WINDOWS_ARCH := i686
+  else
+    WINDOWS_ARCH := x86_64
+  endif
+endif
+# for dh_install substitution variable
+export WINDOWS_ARCH
 
 MAKE_OPTIMISATIONS := true
 ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
@@ -190,10 +205,3 @@
 		"$<" > "$@"
 	if $(DOWNLOAD_BOOTSTRAP) || [ $(HAVE_BINARY_TARBALL) != 0 ]; \
 	  then sed -i -e '/^rustc = /d' -e '/^cargo = /d' "$@"; fi
-# Work around low-memory (32-bit) architectures: https://github.com/rust-lang/rust/issues/45854
-ifneq (,$(filter $(DEB_BUILD_ARCH), armhf armel i386 mips mipsel powerpc powerpcspe))
-	sed -i -e 's/^debuginfo-level = .*/debuginfo-level = 0/g' "$@"
-endif
-
-check-no-old-llvm:
-	# fail the build if we have any instances of OLD_LLVM_VERSION in debian, except for debian/changelog
